<template>
	<div>
		<v-snackbar v-model="snack" :timeout="timeout" top color="#72a051"
			>Cierre de convocatoria actualizada</v-snackbar
		>
		<v-dialog v-model="visibleForm" persistent max-width="500">
			<v-card>
				<v-card-title
					>Establezca una fecha para cierre de
					convocatoria</v-card-title
				>
				<v-card-text>
					<v-row justify-sm="center">
						<v-date-picker
							v-model="limitDate"
							color="#c51f2f"
							full-width
							landscape
							locale="es-419"
						></v-date-picker>
					</v-row>
				</v-card-text>
				<v-card-actions>
					<v-row justify="center" justify-sm="space-around">
						<v-col cols="12" sm="4">
							<v-btn
								:loading="loading"
								outlined
								block
								color="success"
								@click="establishLimitDate"
								>Confirmar</v-btn
							>
						</v-col>
						<v-col cols="12" sm="4">
							<v-btn
								outlined
								block
								color="red"
								@click="closeFormLimitDate"
								>Cancelar</v-btn
							>
						</v-col>
					</v-row>
				</v-card-actions>
			</v-card>
		</v-dialog>
	</div>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";

export default {
	name: "FormLimitDate",
	props: ["visibleForm"],
	data: () => ({
		limitDate: new Date().toISOString().substr(0, 10),
		timeout: 2000,
		loading: false,
		snack: false
	}),
	methods: {
		// Establece una fecha limite para el cierre de convicatoria
		async establishLimitDate() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($date: String!) {
							establishLimitDate(date: $date)
						}
					`,
					variables: {
						date: this.limitDate
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.snack = true;
					setTimeout(() => {
						this.closeFormLimitDate();
					}, 2000);
				}, 2000);
			} catch (error) {}
		},
		// Cierra el modal del calendario
		closeFormLimitDate() {
			EventBus.$emit("closeFormLimitDate");
		}
	},
	mounted() {
		// cierra el formulario de fecha límite con la tecla ESC
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeFormLimitDate();
			}
		});
	}
};
</script>
